/*********************************************
* 
* @Author: Eylon Yogev
*********************************************/

try {

    HeadupClass.prototype.RemoveElementScript =
"function RemoveFromPageById(element)" +
"{" +
	"var parent = element.parentNode;" +
"	parent.removeChild(element);" +
"}";


    function IdGenerator (prefix) {
        var runningId = -1;
        var fixture = prefix;

        this.NewId = function() {
            runningId++;
            return fixture + runningId;
        }
    }

    HeadupClass.prototype.scriptIdGenertaor = new IdGenerator("headupScript");

    HeadupClass.prototype.EvalOnPage = function(page, script) {
        try {
            var pageHead = page.getElementsByTagName("head")[0];
            var scriptId = this.scriptIdGenertaor.NewId();
            var wrappedScript = this.RemoveElementScript + " try {" + script + " } catch (err){}RemoveFromPageById(document.getElementById('" + scriptId + "')); ";
            this.InjectScriptElementText(wrappedScript, pageHead, page, scriptId);
        }
        catch (err) {
            gHeadup.LogError('EvalOnPage', err);
        }
    }

    HeadupClass.prototype.InjectScriptFromSrc = function(src, page) {
        var pageHead = page.getElementsByTagName("head")[0];
        var newElement = page.createElement("script");
        newElement.setAttribute("type", "text/javascript");
        newElement.setAttribute("src", src);
        pageHead.appendChild(newElement);
    }

    HeadupClass.prototype.InjectScriptElementToHead = function(scriptText, page) {
        var pageHead = page.getElementsByTagName("head")[0];
        this.InjectScriptElementText(scriptText, pageHead, page);
    }

    HeadupClass.prototype.InjectScriptElementFile = function(scriptPath, rootElement, page) {
        var elementContent;
        elementContent = GetScriptText(scriptPath);

        this.InjectScriptElementText(elementContent, rootElement, page);
    }

    HeadupClass.prototype.InjectScriptElementText = function(scriptText, rootElement, page, scriptBlockId) {

        try {

            var newElement, elementContent;

            var scriptId = scriptBlockId == null ? scriptIdGenertaor.NewId() : scriptBlockId;
            newElement = page.createElement("script");
            newElement.setAttribute("type", "text/javascript");

            newElement.setAttribute("id", scriptId);
            elementContent = page.createTextNode(scriptText);
            newElement.appendChild(elementContent);
            rootElement.appendChild(newElement);
        }
        catch (e) {

            gHeadup.LogError('InjectScriptElementText', e);
        }
    }

}
catch (err) {
    gHeadup.LogError('error prototyping Injection: ' + err);
}